hdu 5348 MZL's endless loop 暴搜

链接:http://acm.hdu.edu.cn/showproblem.php?pid=5348

MZL‘s endless loop

Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)

Total Submission(s): 1426    Accepted Submission(s): 319

Special Judge

Problem Description

As we all kown, MZL hates the endless loop deeply, and he commands you to solve this problem to end the loop.

You are given an undirected graph with n vertexs
and m edges.
Please direct all the edges so that for every vertex in the graph the inequation |out degree ? in degree|≤1 is
satisified.

The graph you are given maybe contains self loops or multiple edges.

Input

The first line of the input is a single integer T,
indicating the number of testcases.

For each test case, the first line contains two integers n and m.

And the next m lines,
each line contains two integers ui and vi,
which describe an edge of the graph.

T≤100, 1≤n≤105, 1≤m≤3?105, ∑n≤2?105, ∑m≤7?105.

Output

For each test case, if there is no solution, print a single line with ?1,
otherwise output m lines,.

In ith
line contains a integer 1 or 0, 1 for
direct the ith
edge to ui→vi, 0 for ui←vi.

Sample Input

2
3 3
1 2
2 3
3 1
7 6
1 2
1 3
1 4
1 5
1 6
1 7

Sample Output

1
1
1
0
1
0
1
0
1

题意:给n点m条无向边,要给每条边定一个方向,最后图中所有点的出入度差小于等于1.

做法:暴搜,注意用完的边要删去,更新下head就可以删边了。 然后 每个dfs 只找一条路径, 找到后就break。

#pragma comment(linker, "/STACK:102400000,102400000")
#include <stdio.h>
#include <string>
#include <iostream>
using namespace std;

const int N=100100;
const int M=300100;

struct Edge{
	int to,  nex , id , fan;
}edge[M*2];
int head[N],edgenum;//2个要初始化-1和0

void add(int u, int v, int id ,int fan)
{
	Edge E = { v,  head[u], id, fan};
	edge[ edgenum ] = E;
	head[ u ] = edgenum++;
}
void init(){edgenum=0;}
//for(int i=head[nw];i!=-1;i=edge[i].nex)

int du[N];//出减  入加
int bian[M];

void dfs(int nw,int fx)
{
	for(int i=head[nw];i!=-1;i=head[nw])
	{
		int to=edge[i].to;
		if(bian[edge[i].id]==-1)//还没确定方向
		{
			if(du[nw]!=-1&&du[to]!=1&&fx!=2)
			{
				du[nw]--;
				du[to]++;
				bian[edge[i].id]=(1^edge[i].fan);
				head[nw]=edge[i].nex;
				dfs(to,1);
			}
			else if(du[nw]!=1&&du[to]!=-1&&fx!=1)
			{
				du[nw]++;
				du[to]--;
				bian[edge[i].id]=(0^edge[i].fan);
				head[nw]=edge[i].nex;
				dfs(to,2);
			}
			else
				continue;
			break;
		}
		else
			head[nw]=edge[i].nex;//删边
	}
}
int main()
{
	int t;
	scanf("%d",&t);
	while(t--)
	{
		int n,m;
		init();
		scanf("%d%d",&n,&m);
		for(int i=1;i<=n;i++)
			head[i]=-1;
		for(int i=0;i<m;i++)
		{
			bian[i]=-1;
			int u,v;
			scanf("%d%d",&u,&v);
			if(u==v)
			{
				bian[i]=0;
				continue;
			}
			add(u,v,i,0);
			add(v,u,i,1);
		}
		for(int i=1;i<=n;i++)
			du[i]=0;
		for(int i=1;i<=n;i++)
		{
			while(head[i]!=-1)
				dfs(i,0);
		}
		for(int i=0;i<m;i++)
			printf("%d\n",bian[i]);
	}
	return 0;
}

版权声明:本文为博主原创文章,未经博主允许不得转载。

hdu 5348 MZL's endless loop 暴搜

时间: 2024-10-29 19:10:22

hdu 5348 MZL's endless loop 暴搜的相关文章

HDU 5348 MZL&#39;s endless loop(思想用的是深搜)经典

MZL's endless loop Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 1343    Accepted Submission(s): 282 Special Judge Problem Description As we all kown, MZL hates the endless loop deeply, and

【搜索】HDU 5348 MZL&#39;s endless loop

通道 题意:给出n个点,m条边,现在要给边定向使得点的出度和入度的差不超过1 思路: 对每个点进行出度和入度的判断,如果出度大,就先进行反向的搜索(每搜索一条边u,v就认为这是一条v到u的有向边),反之,进行正向搜索(每搜到一条边u,v认为这是一条u到v的有向边),一直搜索到找不到边能继续为止,每条边只遍历一次 代码: #pragma comment(linker, "/STACK:102400000,102400000") #include <cstdio> #inclu

HDU 5348 MZL&#39;s endless loop 给边定向(欧拉回路,最大流)

题意:给一个所有你可能想得到的奇葩无向图,要求给每条边定向,使得每个点的入度与出度之差不超过1.输出1表示定向往右,输出0表示定向往左. 思路: 这题本来很简单的事,在每两个奇数度的点添加1条无向边,就变成了个欧拉回路了.欧拉回路的定义时,只要每个点的度为偶数,必定有欧拉回路的存在.只需要选择任1个点出发,遍历每条边仅1次,得到就是欧拉回路路径了,再根据每条边的方向选0/1.添加的那些无向边都是不会影响答案的,因为欧拉回路跑得起来肯定是每个点的出度等于入度,而每个点最多只会被多加1条边,根据题目

HDU 5348 MZL&#39;s endless loop

乱搞题...第一直觉是混合图的欧拉通路,但是感觉并没有多大关系.最终AC的做法是不断的寻找欧拉通路,然后给边标号.所有边访问了一遍,所有点访问了一遍,效率是o(n+m).不存在-1的情况. #include<cstdio> #include<cstring> #include<cmath> #include<vector> #include<algorithm> using namespace std; const int maxn=100000

hdu 5348 MZL&#39;s endless loop 欧拉回路

MZL's endless loop Time Limit: 3000/1500 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 1502    Accepted Submission(s): 331Special Judge Problem Description As we all kown, MZL hates the endless loop deeply, and h

Hdu 5348 MZL&#39;s endless loop (dfs)

题目链接: Hdu 5348 MZL's endless loop 题目描述: 给出一个无向图(有环,有重边),包含n个顶点,m条边,问能否给m条边指定方向,使每个顶点都满足abs(出度-入度)<2.如果能输出任意一种合法方案. 解题思路: 其实仔细考虑一下,每个无向图都会存在合法方案的.证明:度数和为奇数的点只能为起点或者终点,度数为偶数的只能是环上的起点或者终点或者是中间点.有m条边,一共有2*m个端点.所以呢?当然是度数和为奇数的个肯定是偶数个,任意两个相结合都可以形成一条路.并不会有两条

图论 HDOJ 5348 MZL&#39;s endless loop

题目传送门 1 /* 2 题意:给一个n个点,m条边的无向图,要求给m条边定方向,使得每个定点的出入度之差的绝对值小于等于1. 输出任意一种结果 3 图论:一个图,必定存在偶数个奇度顶点.那么从一个奇度定点深搜,当碰到另外一个奇度顶点时结束,这样能保证度数差<=1 3.5 详细解释:http://blog.csdn.net/ZSGG_ACM/article/details/47287681 4 */ 5 /*********************************************

hdu 5348 MZL&amp;#39;s endless loop

给一个无向图(事实上是有向的.可是没有指定边的方向),你须要指定边的方向,使得每一个点入度和出度相差不超过1. 事实上就是找很多条路径.合起来能走完这个图..先统计各个顶点的度.度为奇数必是起点或终点,否则是中间点或者同为起点和终点. 邻接表建图(建双向),先从每一个奇数度顶点出发找路径,再从偶数度顶点出发找路径.经过的边要删去不然超时. #include <iostream> #include <cstring> #include <cstdio> #include

[2015hdu多校联赛补题]hdu5348 MZL&#39;s endless loop

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5348 题意:给你一个无向图,要你将无向图的边变成有向边,使得得到的图,出度和入度差的绝对值小于等于1,如果无解输出-1 解:考虑奇数度的点一定会成对出现(因为所有度数和肯定是偶数个->因为一条边产生两度~),那么我们可以将奇数度的点两两一连消除掉(两奇数度点的出度入读差的绝对值都为1, 路径上的点的差绝对值为0) 然后偶数度的点可以成环,那么可以搜出所有的环 1 /* 2 * Problem: 3